/* =========================================================================

NAME: MultiPrint

AUTHOR: Oleg Butrin (obutrin@indesign.rudtp.ru) + ragman (special946@gmail.com)
HOMEPAGE: http://indesign.rudtp.ru
DATE  : 10.02.2004 15:13

COMMENT:
Script print all open documents into the chosen folder or directly on printer

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

============================================================================ */
//    
//@include 'MultiPrint.ini';
//@include 'MultiPrint.ru.slang';

with (app) {
//    
	if (documents.length<1) {
		alert(langNoDocs);
		exit();
	}
//    	
	var myPrinterPresNames = new Array();
	for (myCounter = 0; myCounter < printerPresets.length; myCounter++) {
		myPrinterPresNames[myCounter] = printerPresets[myCounter].name;
	}
//      PDF 	
	var myPDFPresNames = new Array();
	for (myCounter = 0; myCounter < pdfExportPresets.length; myCounter++) {
		myPDFPresNames[myCounter] = pdfExportPresets[myCounter].name;
	}

//  
	var myDialog = dialogs.add({name:iniScriptName + " " + iniScriptVersion})
	var myFileNameArr = new Array();
//   
	with (myDialog.dialogColumns.add()) {
		with (borderPanels.add().dialogColumns.add()) {
			dialogRows.add().staticTexts.add({staticLabel:langFileSelect});	
			for (myCounter=0; myCounter<documents.length; myCounter++) {
				with (dialogRows.add()) {
					myFileNameArr[myCounter] = checkboxControls.add({staticLabel:getFileNameOnly(documents[myCounter].name), checkedState:true});
				}
			}
		}
	}

//   
	with (myDialog.dialogColumns.add()) {
		with (borderPanels.add().dialogColumns.add()) {
			dialogRows.add().staticTexts.add({staticLabel:langPrintSelect});
				with (dialogRows.add()) {
					var mySelectOption = radiobuttonGroups.add();
					with (dialogColumns.add()) {
						mySelectPrint = mySelectOption.radiobuttonControls.add({staticLabel:langPrintStyle, checkedState:iniPrintStyleOn});
						mySelectPDF = mySelectOption.radiobuttonControls.add({staticLabel:langPDFStyle, checkedState:iniPDFStyleOn});	
					}
					with (dialogColumns.add()) {
						var myPrinterPresSelect = dropdowns.add({stringList:myPrinterPresNames, selectedIndex:iniDefPrintStyleNum, minWidth:173});
						var myPDFPresSelect = dropdowns.add({stringList:myPDFPresNames, selectedIndex:iniDefPDFStyleNum, minWidth:173});
						var myShowDialog = checkboxControls.add({staticLabel:langShowDialog, checkedState:iniShowDialog});
					}
				}
		}
//   		
		with (borderPanels.add().dialogColumns.add()) {
			dialogRows.add().staticTexts.add({staticLabel:langOptionSelect});
			var myCreateFolder = checkboxControls.add({staticLabel:langCreateSeperateFolder, checkedState:iniCreateSeparateFolder});
			with(dialogRows.add()) {
				with (dialogColumns.add()) {
					dialogRows.add().staticTexts.add({staticLabel:langFolderPattern});
					dialogRows.add().staticTexts.add({staticLabel:langFilePattern});
				}
				with (dialogColumns.add()) {
					var myFolderPattern = dialogRows.add().textEditboxes.add({editContents:iniFolderPattern, minWidth:180})
					var myFilePattern = dialogRows.add().textEditboxes.add({editContents:iniFilePattern, minWidth:180})
				}
			}
			dialogRows.add().staticTexts.add({staticLabel:iniFolderTag + " " + langCurrentDocName});
			dialogRows.add().staticTexts.add({staticLabel:iniPageTag + " " + langCurrentPageNumber});
		}			
	}	
//	
	
// 
	var myResult = myDialog.show();
	if (myResult == false) {
		myDialog.destroy();
		exit();
	}
//,    	
	if (mySelectOption.selectedButton == 0) {
		var myPrinter = printerPresets[myPrinterPresSelect.selectedIndex];
//  ppd
		try {
			var myPPD = myPrinter.ppd;
		}
		catch (error) {
			var myPPD = null;
		}
//   ,      
		if (!myPPD) {
			if (confirm(langPrintDirectly)) {
				for (myCounter = 0; myCounter < documents.length; myCounter++) {
					if(myFileNameArr[myCounter].checkedState) {
						documents[myCounter].printPreferences.pageRange = 1886547553;
						documents[myCounter].print(myShowDialog.checkedState, myPrinter);
					}
				}
			} else {
				myDialog.destroy();
				exit();
			}
		}	
//,     
		if (printerPresets[myPrinterPresSelect.selectedIndex].printer == "Acrobat Distiller") {
			alert (langPDFOnly);
			myDialog.destroy();
			exit();
		}
	}
//ragman   
	var mySelectedFolder = new Folder (iniSelectedFolder);
//    ,   
	if (!mySelectedFolder.exists) {
//    
		mySelectedFolder = Folder.selectDialog(langSelectFolder, "~" );
		if (mySelectedFolder == null) {
			alert(langFolderNotSpec);
			exit();
		}
	}
//  
	for (myCounter = 0; myCounter < documents.length; myCounter++) {
		if(myFileNameArr[myCounter].checkedState) {
//     
			if (myCreateFolder.checkedState) {
				var myCurrentFolder = new Folder (mySelectedFolder + "/" + patternFolderName(documents[myCounter].name, iniFolderTag, myFolderPattern.editContents));
//    
				if (myCurrentFolder.create() || myCurrentFolder.exists) {
					var myExportFolder = myCurrentFolder
				}
			}
			else {
//    -    
				var myExportFolder = mySelectedFolder;
			}
//    
			for (pg = 0; pg < documents[myCounter].pages.length; pg++) {
// ,     
				switch (mySelectOption.selectedButton) {
// , 
					case 0: 
//    
						var myRealPageNumber = documents[myCounter].pages[pg].appliedSection.pageNumberStart + pg;
//          
						myPrinter.printFile = new File (myExportFolder + "/" + patternDocumentName(documents[myCounter].name, myRealPageNumber, iniFolderTag, iniPageTag,  myFilePattern.editContents) + ".ps");
//  
						documents[myCounter].printPreferences.pageRange = String(myRealPageNumber);
// 
						documents[myCounter].print(myShowDialog.checkedState, myPrinter);
						break;
//     PDF
					case 1:
						var myRealPageNumber = documents[myCounter].pages[pg].appliedSection.pageNumberStart + pg;
						var myPrintFile = new File (myExportFolder + "/" + patternDocumentName(documents[myCounter].name, myRealPageNumber, iniFolderTag, iniPageTag,  myFilePattern.editContents) + ".pdf");
						pdfExportPreferences.pageRange = String(myRealPageNumber);
//						
						documents[myCounter].exportFile(ExportFormat.pdfType, myPrintFile, false);						
						break;
				}
			}
		}
	}	

//
	myDialog.destroy();
	exit();
}
//:

//          
function patternDocumentName (myDocName, myPageNum, myDocTag, myPageTag, myPattern) {
	var myString = myPattern.replace(myDocTag, getFileNameOnly(myDocName));
	myString = myString.replace(myPageTag, myPageNum);
	return myString;
}
//        
function patternFolderName (myDocName, myTag, myPattern) {
	var myString = myPattern.replace(myTag, getFileNameOnly(myDocName));
	return myString;
}
//          ( )
function getFileNameOnly (myFileName) {
	var myString = "";
	var myResult = myFileName.lastIndexOf(".");
	if (myResult == -1) {
		myString = myFileName;
	}
	else {
		myString = myFileName.substr(0, myResult);
	}
	return myString;
}